package guru.animator;
public class LinearAnimator implements Animator {
    long starttime = 0;
    long dur = 0;
        float start = 0;
        float end =0;
    boolean running = false;

    public LinearAnimator( long dur, float start, float end ) {
        this.start = start;
        this.end = end;
        this.dur = dur;
    }

    public void start() {
        this.starttime = System.currentTimeMillis();
        this.running = true;
    }


    public float get() {
        if (!running) {
            return ( starttime == 0 ? start : end );
        } else {
            long now = System.currentTimeMillis() - starttime;
            if ( now > dur ) {
                running = false;
                return end;
            } else {
                float d = (float)now/(float)dur;
                return start + ( end - start ) * d;
            }
        }
    }

    public boolean isRunning() {
        return running;
    }

    public void reset() {
        this.starttime = 0;
        this.running = false;
    }

    public boolean isDone() {
        return ( !running && starttime > 0 );
    }

}
